; mozParty/theme.jl

;; Copyright (C) 2000 Pierre Baillargeon <pierreba@globetrotter.net>

;; This theme is derived from the Mozilla web site.


(let*
    (
     (mzp-top-left-images (list (make-image "inactive.png")
				(make-image "top-left.png")))

     (mzp-left-images (list (make-image "inactive.png")
                            (make-image "left.png")))

     (mzp-bottom-left-images (list (make-image "inactive.png")
				   (make-image "bottom-left.png")))

     (mzp-close-images (list (make-image "close-inactive.png")
			     (make-image "close.png")
			     (make-image "close-inactive.png")
			     (make-image "close-clicked.png")))

     (mzp-top-images (list (make-image "inactive.png")
			   (make-image "top.png")))

     (mzp-title-images (list (make-image "title-inactive.png")
			     (make-image "title.png")))

     (mzp-top-right-images (list (make-image "inactive.png")
				 (make-image "top-right.png")))

     (mzp-right-images (list (make-image "inactive.png")
                             (make-image "right.png")))

     (mzp-bottom-right-images (list (make-image "inactive.png")
				    (make-image "bottom-right.png")))

     (mzp-bottom-images (list (make-image "inactive.png")
			      (make-image "bottom.png")))

     (mzp-maximize-images (list (make-image "max-inactive.png")
				(make-image "max.png")
				(make-image "max-inactive.png")
				(make-image "max-clicked.png")))

     (mzp-iconify-images (list (make-image "min-inactive.png")
			       (make-image "min.png")
			       (make-image "min-inactive.png")
			       (make-image "min-clicked.png")))

     ;; frame layout

     (frame `(((background . ,mzp-top-left-images)
	       (left-edge . -6)
	       (top-edge . -28)
	       (class . top-left-corner))

	      ;; left border
	      ((background . ,mzp-left-images)
	       (left-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; bottom-left corner
	      ((background . ,mzp-bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; top
	      ((background . ,mzp-top-images)
	       (top-edge . -28)
	       (left-edge . 0)
	       (right-edge . 0)
	       (class . top-border))

	      ;; delete button
	      ((background . ,mzp-title-images )
	       (top-edge . -22)
	       (left-edge . 0)
	       (width . 30)
	       (class . title))

	      ;; delete button
	      ((background . ,mzp-close-images )
	       (top-edge . -30)
	       (left-edge . -6)
	       (class . close-button))

	      ;; title
	      ((background . ,mzp-title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . left)
	       (y-justify . top)
	       (top-edge . -22)
	       (left-edge . 30)
	       (right-edge . 0)
	       (class . title))

	      ;; top-right corner
	      ((background . ,mzp-top-right-images)
	       (right-edge . -6)
	       (top-edge . -28)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,mzp-right-images)
	       (right-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom-right corner
	      ((background . ,mzp-bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,mzp-bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))

	      ;; iconify button
	      ((background . ,mzp-iconify-images)
	       (right-edge . 18)
	       (top-edge . -30)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,mzp-maximize-images)
	       (right-edge . -4)
	       (top-edge . -30)
	       (class . maximize-button))
					 ))
     (shaped-frame `(((background . ,mzp-top-left-images)
	       (left-edge . -6)
	       (top-edge . -28)
	       (class . top-left-corner))

	      ;; left border
	      ((background . ,mzp-left-images)
	       (left-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; bottom-left corner
	      ((background . ,mzp-bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; top
	      ((background . ,mzp-top-images)
	       (top-edge . -28)
	       (left-edge . 0)
	       (right-edge . 0)
	       (class . top-border))

	      ;; delete button
	      ((background . ,mzp-title-images )
	       (top-edge . -22)
	       (left-edge . 0)
	       (width . 30)
	       (class . title))

	      ;; delete button
	      ((background . ,mzp-close-images )
	       (top-edge . -30)
	       (left-edge . -6)
	       (class . close-button))

	      ;; title
	      ((background . ,mzp-title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . left)
	       (y-justify . top)
	       (top-edge . -22)
	       (left-edge . 30)
	       (right-edge . 0)
	       (class . title))

	      ;; top-right corner
	      ((background . ,mzp-top-right-images)
	       (right-edge . -6)
	       (top-edge . -28)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,mzp-right-images)
	       (right-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom-right corner
	      ((background . ,mzp-bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,mzp-bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))

	      ;; iconify button
	      ((background . ,mzp-iconify-images)
	       (right-edge . 18)
	       (top-edge . -30)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,mzp-maximize-images)
	       (right-edge . -4)
	       (top-edge . -30)
	       (class . maximize-button))
					 ))
     (transient-frame `(((background . ,mzp-top-left-images)
	       (left-edge . -6)
	       (top-edge . -28)
	       (class . top-left-corner))

	      ;; left border
	      ((background . ,mzp-left-images)
	       (left-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; bottom-left corner
	      ((background . ,mzp-bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; top
	      ((background . ,mzp-top-images)
	       (top-edge . -28)
	       (left-edge . 0)
	       (right-edge . 0)
	       (class . top-border))

	      ;; delete button
	      ((background . ,mzp-title-images )
	       (top-edge . -22)
	       (left-edge . 0)
	       (width . 30)
	       (class . title))

	      ;; delete button
	      ((background . ,mzp-close-images )
	       (top-edge . -30)
	       (left-edge . -6)
	       (class . close-button))

	      ;; title
	      ((background . ,mzp-title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . left)
	       (y-justify . top)
	       (top-edge . -22)
	       (left-edge . 30)
	       (right-edge . 0)
	       (class . title))

	      ;; top-right corner
	      ((background . ,mzp-top-right-images)
	       (right-edge . -6)
	       (top-edge . -28)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,mzp-right-images)
	       (right-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom-right corner
	      ((background . ,mzp-bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,mzp-bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))
					 ))
     (shaped-transient-frame `(((background . ,mzp-top-left-images)
	       (left-edge . -6)
	       (top-edge . -28)
	       (class . top-left-corner))

	      ;; left border
	      ((background . ,mzp-left-images)
	       (left-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; bottom-left corner
	      ((background . ,mzp-bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; top
	      ((background . ,mzp-top-images)
	       (top-edge . -28)
	       (left-edge . 0)
	       (right-edge . 0)
	       (class . top-border))

	      ;; delete button
	      ((background . ,mzp-title-images )
	       (top-edge . -22)
	       (left-edge . 0)
	       (width . 30)
	       (class . title))

	      ;; delete button
	      ((background . ,mzp-close-images )
	       (top-edge . -30)
	       (left-edge . -6)
	       (class . close-button))

	      ;; title
	      ((background . ,mzp-title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . left)
	       (y-justify . top)
	       (top-edge . -22)
	       (left-edge . 30)
	       (right-edge . 0)
	       (class . title))

	      ;; top-right corner
	      ((background . ,mzp-top-right-images)
	       (right-edge . -6)
	       (top-edge . -28)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,mzp-right-images)
	       (right-edge . -6)
	       (top-edge . -22)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom-right corner
	      ((background . ,mzp-bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,mzp-bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))
					 ))


					     )
  
  (add-frame-style 'mozParty
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame))))

  )
